<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Performance &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="API Documentation" href="heiwa.html" />
    <link rel="prev" title="Heiwa documentation" href="index.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Performance</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#forum-apis">Forum APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#listing-with-permissions-parsed">Listing with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#listing-with-permissions-not-yet-parsed">Listing with permissions not yet parsed</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#thread-apis">Thread APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#listing-in-a-single-forum-with-permissions-parsed">Listing in a single forum with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#listing-in-multiple-forums-with-permissions-parsed">Listing in multiple forums with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#listing-in-multiple-forums-with-permissions-not-parsed">Listing in multiple forums with permissions not parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#creating">Creating</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#post-apis">Post APIs</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#id1">Listing in a single forum with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#id2">Listing in multiple forums with permissions parsed</a></li>
<li class="toctree-l3"><a class="reference internal" href="#id3">Listing in multiple forums with permissions not parsed</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.html">API Documentation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
      <li>Performance</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/performance.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="performance">
<h1>Performance<a class="headerlink" href="#performance" title="Permalink to this headline"></a></h1>
<p>As it’s the only fully supported SQL dialect right now, PostgreSQL was used as
the database backend. When testing occurs, the server has already been running
and received idle requests for a few minutes.</p>
<dl class="simple">
<dt>All tests were performed on a ThinkPad X260:</dt><dd><ul class="simple">
<li><p>CPU: Intel i5-6300U - 4 cores, 2.4 Ghz</p></li>
<li><p>RAM: Samsung M471A1K43CB1-CRC - 8GB DDR4 &#64; 2133 MHz</p></li>
<li><p>SSD: Intel SSDSC2KF48 - 480GB, 492.4MB/s read, TODO write, 0.12ms access time</p></li>
<li><p>Power management on performance mode, charger plugged in</p></li>
</ul>
</dd>
</dl>
<p>Programs used for testing can be found in the
<a class="reference external" href="https://gitlab.com/tomas.hz/useful-utilities">useful utilities</a> repository.
Generally, measurements are done in a single thread so as to avoid unrealistic
load all at once.</p>
<section id="forum-apis">
<h2>Forum APIs<a class="headerlink" href="#forum-apis" title="Permalink to this headline"></a></h2>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.views.forum.html"><span class="doc">Original API views</span></a></p>
</div>
<section id="listing-with-permissions-parsed">
<h3>Listing with permissions parsed<a class="headerlink" href="#listing-with-permissions-parsed" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.38.</em></p>
<p>The average for a realistic 50 results was <strong>45.5ms</strong>. At 512 results - the
default limit, but one rarely seen in the real world outside data scraping and
cloning - the average was <strong>72.97ms</strong>. All forums’ permissions were already
parsed at the time they were listed, unlike the metric following this one.
There were always 512 or more forums available.</p>
<img alt="A chart showing the results" src="_images/forum-list-parsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/f4653e2cd1bdec038cded80aa768c3f2/forum-list-parsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="listing-with-permissions-not-yet-parsed">
<h3>Listing with permissions not yet parsed<a class="headerlink" href="#listing-with-permissions-not-yet-parsed" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.38.</em></p>
<p>The average for a realistic 50 results was <strong>395.12ms</strong>. While this is a lot,
the respective forums’ permissions will remain parsed forever until an
administrator changes them. With 512 results, the default limit, the average
was <strong>3403.85ms</strong>. There were always 512 or more forums available. The cached
parsed permissions were deleted with each new measurement.</p>
<img alt="A chart showing the results" src="_images/forum-list-unparsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/ea87595a12dec335a00afda59838f3aa/forum-list-unparsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
</section>
<section id="thread-apis">
<h2>Thread APIs<a class="headerlink" href="#thread-apis" title="Permalink to this headline"></a></h2>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.views.thread.html"><span class="doc">Original API views</span></a></p>
</div>
<section id="listing-in-a-single-forum-with-permissions-parsed">
<h3>Listing in a single forum with permissions parsed<a class="headerlink" href="#listing-in-a-single-forum-with-permissions-parsed" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.38.</em></p>
<p>The average for a realistic 50 results was <strong>48.3ms</strong>. At 512 results, the
average was <strong>112.55ms</strong>. All threads belonged to a single forum, whose
permissions were already known in advance.</p>
<img alt="A chart showing the results" src="_images/thread-list-single-parsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/158a6f918da51c79b8b272ab55711cfd/thread-list-single-parsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="listing-in-multiple-forums-with-permissions-parsed">
<h3>Listing in multiple forums with permissions parsed<a class="headerlink" href="#listing-in-multiple-forums-with-permissions-parsed" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.41.</em></p>
<p>The average for a realistic 50 results was <strong>48.85ms</strong>. At 512 results, the
average was <strong>113.74ms</strong>. In total, every thread belonged to one of 50 forums,
whose permissions were already parsed.</p>
<p>Load like this is most often seen when users search for specific content. For
example, threads containing links in any forum, created in the last few days.</p>
<p>That said, there seemed to be no meaningful difference, with the extra ~1ms
likely resulting from a statistical inaccuracy.</p>
<img alt="A chart showing the results" src="_images/thread-list-multiple-parsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/f3c87b14c1f5e36bd06c928b9a78715e/thread-list-multiple-parsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="listing-in-multiple-forums-with-permissions-not-parsed">
<h3>Listing in multiple forums with permissions not parsed<a class="headerlink" href="#listing-in-multiple-forums-with-permissions-not-parsed" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.41.</em></p>
<p>The average for a realistic 50 results was <strong>388.41ms</strong>. At 512 results, the
average was <strong>466.3ms</strong>, not significantly higher than the average for 50. In
total, every thread belonged to one of 50 forums, whose permissions were not
parsed and deleted with each new measurement.</p>
<p>Load like this is most often seen when new users search for threads containing
specific content and the related forums’ permissions have not yet had a chance
to be parsed. For example, child forums which are usually not visible on the
index page of frontend programs.</p>
<p>There is a visible trend of the response time rapidly increasing with the first
few requests, then nearly leveling out. This likely resulted from the first 50
threads’ forums being unique, each increasing the average response time by how
long it takes to parse its permissions.</p>
<img alt="A chart showing the results" src="_images/thread-list-multiple-unparsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/38b9e1ab03c06a0fd383c8364844caae/thread-list-multiple-unparsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="creating">
<h3>Creating<a class="headerlink" href="#creating" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.38.</em></p>
<p>The average amount of time it took to create a thread was <strong>45.33ms</strong>. The
forum was the same each time and its permissions were already calculated.</p>
<img alt="A chart showing the results" src="_images/thread-create-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/d5db753a4c2c106bd804d1b80658effb/thread-create-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
</section>
<section id="post-apis">
<h2>Post APIs<a class="headerlink" href="#post-apis" title="Permalink to this headline"></a></h2>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.views.post.html"><span class="doc">Original API views</span></a></p>
</div>
<section id="id1">
<h3>Listing in a single forum with permissions parsed<a class="headerlink" href="#id1" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.41.</em></p>
<p>The average for a realistic 50 results was <strong>42.95ms</strong>. At 512, the average
was <strong>98.12ms</strong>. All posts belonged to a single thread’s forum, whose
permissions were already known in advance.</p>
<img alt="A chart showing the results" src="_images/post-list-single-parsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/96b9acf600005c90a03962d816c7a602/post-list-single-parsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="id2">
<h3>Listing in multiple forums with permissions parsed<a class="headerlink" href="#id2" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.41.</em></p>
<p>The average for a realistic 50 results was <strong>42.05ms</strong>. At 512 results, the
average was <strong>78.92ms</strong>. In total, every post’s thread belonged to one of 50
forums, whose permissions were already parsed.</p>
<img alt="A chart showing the results" src="_images/post-list-multiple-parsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/d7a358f792440335013438d5b80c5a24/post-list-multiple-parsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
<section id="id3">
<h3>Listing in multiple forums with permissions not parsed<a class="headerlink" href="#id3" title="Permalink to this headline"></a></h3>
<p><em>Last measured on version 0.17.41.</em></p>
<p>The average for a realistic 50 results was <strong>384.41ms</strong>. At 512 results, the
average was <strong>447.63ms</strong>. In total, every post belonged to one of 50 threads’
forums, whose permissions were not parsed and deleted with each new
measurement. There were always 512 or more posts available.</p>
<img alt="A chart showing the results" src="_images/post-list-multiple-unparsed-chart.png" />
<p><a class="reference download internal" download="" href="_downloads/ae0fc040efa515e05d35afe03335b3eb/post-list-multiple-unparsed-results.csv"><code class="xref download docutils literal notranslate"><span class="pre">CSV</span></code></a></p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="index.html" class="btn btn-neutral float-left" title="Heiwa documentation" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.html" class="btn btn-neutral float-right" title="API Documentation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>